package fr.doap.llog;

import java.util.Set;

public class LogLooper extends ThreadLooper {
	
	public void post(LogMsg aLogMsg) {
		add(new LLMsg(aLogMsg));
	}
	
	public void put(String aKey, Filter aF) {
		mFilters.put(aKey, aF);
	}
	
	public class LLMsg implements WorkItem {
		public LLMsg(LogMsg aLogMsg) { mLogMsg = aLogMsg; }
		
		@Override
		public void run() {
			int lI = mLogMsg.getCallerIndex();
			StackTraceElement lS = mLogMsg.mSTE[lI];
			String lClass = lS.getClassName();
			lClass = lClass.substring(lClass.lastIndexOf('.'));
			if (mLogMsg.mTag == null || mLogMsg.mTag.isEmpty()) mLogMsg.mTag = lClass;
			String lC = lS.getClassName() + "." + lS.getMethodName();
			Filter lF = mFilters.get(lC);
			if (lF != null) {
				if (mLogMsg.mSeverity >= lF.mLogLevel) {
					System.out.println(mLogMsg.mSeverity+ "-" + lC + ": " + mLogMsg.mMessage + " (" + lS.getFileName() + ":" + lS.getLineNumber() + ")");
					if (mLogMsg.mSeverity <= lF.mSTLevel) {
						for (int i=lI+1; i<mLogMsg.mSTE.length; i++) {
							StackTraceElement l = mLogMsg.mSTE[i];
							System.out.println("   "+l.getClassName() + "." + l.getMethodName() + " (" + l.getFileName() + ":" + l.getLineNumber() + ")");
						}
					}
				}
			} else {
				System.out.println(lS.getClassName() + "." + lS.getMethodName() + ": " + mLogMsg.mMessage + " (" + lS.getFileName() + ":" + lS.getLineNumber() + ")");
			}
			/*
			for (int i=mLogMsg.getCallerIndex(); i<mLogMsg.mSTE.length; i++) {
				StackTraceElement lS = mLogMsg.mSTE[i];
				System.out.println(lS.getClassName() + "." + lS.getMethodName() + ": " + mLogMsg.mMessage + " (" + lS.getFileName() + ":" + lS.getLineNumber() + ")");
			}
			 */
		}
		
		private LogMsg	mLogMsg;
	}
	
	private	Dict<Filter>	mFilters = new Dict<>();
}
